#include<stdio.h>
#include<stdlib.h>
#include"mpi.h"

#ifdef _USF_MPI_GM_
extern pthread_mutex_t _USF_mut_gm_pending;
extern int request_pending;
extern int thread_recving;
#endif

int
MPI_Startall (int count, MPI_Request * array_of_requests)
{
  int i;
  int pipei = 0;                /* The pipe var. to communicate with comm_thread. */
  int rank, nump;

  pthread_mutex_lock (&_USF_mut_req);
  for (i = 0; i < count; i++) {
    if ((array_of_requests[i])->active != 0) {
      printf ("Error request should have been equal to 0\n");
      pthread_mutex_unlock (&_USF_mut_req);
      exit (0);
    } else {
      (array_of_requests[i])->active = 2;
    }
  }
  pthread_mutex_unlock (&_USF_mut_req);

#ifndef SINGLE_THREAD

#ifdef _USF_MPI_TCP_
  write (_USF_s_pipe[1], &pipei, sizeof (int));
#endif

#ifdef _USF_MPI_GM_
  pthread_mutex_lock (&_USF_mut_gm_pending);
  request_pending++;
  pthread_mutex_unlock (&_USF_mut_gm_pending);
#endif

#else

#ifdef _USF_MPI_TCP_
  MPI_Comm_rank (MPI_COMM_WORLD, &rank);
  MPI_Comm_size (MPI_COMM_WORLD, &nump);
  _USF_serve_mpi_requests (rank, nump);
#endif

#ifdef _USF_MPI_GM_
  request_pending++;
  thread_recving = 1;
  gm_thread ();
#endif

#endif


  return 0;
}
